=== modified file 'drizzled/cached_item.cc'
--- drizzled/cached_item.cc	2010-12-25 01:27:46 +0000
+++ drizzled/cached_item.cc	2010-12-26 22:31:33 +0000
@@ -164,7 +164,7 @@
 Cached_item_decimal::Cached_item_decimal(Item *it)
   :item(it)
 {
-  class_decimal_set_zero(&value);
+  value.set_zero();
 }
 
 

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2010-12-25 01:27:46 +0000
+++ drizzled/drizzled.cc	2010-12-26 22:31:33 +0000
@@ -1112,7 +1112,7 @@
 {
   time_t curr_time;
   umask(((~internal::my_umask) & 0666));
-  class_decimal_set_zero(&decimal_zero); // set decimal_zero constant;
+  decimal_zero.set_zero(); // set decimal_zero constant;
   tzset();			// Set tzname
 
   curr_time= time(NULL);

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2010-12-25 04:38:28 +0000
+++ drizzled/field.cc	2010-12-26 08:07:57 +0000
@@ -915,9 +915,9 @@
 int64_t Field::convert_decimal2int64_t(const type::Decimal *val, bool, int *err)
 {
   int64_t i;
-  if (warn_if_overflow(class_decimal2int(E_DEC_ERROR &
+  if (warn_if_overflow(val->val_int32(E_DEC_ERROR &
                                       ~E_DEC_OVERFLOW & ~E_DEC_TRUNCATED,
-                                      val, false, &i)))
+                                      false, &i)))
   {
     i= (val->sign() ? INT64_MIN : INT64_MAX);
     *err= 1;

=== modified file 'drizzled/field/blob.cc'
--- drizzled/field/blob.cc	2010-12-25 01:27:46 +0000
+++ drizzled/field/blob.cc	2010-12-27 19:16:17 +0000
@@ -286,10 +286,12 @@
     length= 0;
   }
   else
+  {
     length= get_length(ptr);
-
-  str2_class_decimal(E_DEC_FATAL_ERROR, blob, length, charset(),
-                 decimal_value);
+  }
+
+  decimal_value->store(E_DEC_FATAL_ERROR, blob, length, charset());
+
   return decimal_value;
 }
 

=== modified file 'drizzled/field/boolean.cc'
--- drizzled/field/boolean.cc	2010-12-25 01:27:46 +0000
+++ drizzled/field/boolean.cc	2010-12-26 22:31:33 +0000
@@ -135,7 +135,7 @@
 int Boolean::store_decimal(const drizzled::type::Decimal *dec)
 {
   ASSERT_COLUMN_MARKED_FOR_WRITE;
-  if (class_decimal_is_zero(dec))
+  if (dec->is_zero())
   {
     setFalse();
     return 0;
@@ -210,7 +210,7 @@
     return dec;
   }
 
-  class_decimal_set_zero(dec);
+  dec->set_zero();
 
   return dec;
 }

=== modified file 'drizzled/field/decimal.cc'
--- drizzled/field/decimal.cc	2010-12-25 04:38:28 +0000
+++ drizzled/field/decimal.cc	2010-12-27 19:16:17 +0000
@@ -124,18 +124,19 @@
 
 bool Field_decimal::store_value(const type::Decimal *decimal_value)
 {
-  int error= class_decimal2binary(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW,
-                                         decimal_value, ptr, precision, dec);
+  int error= decimal_value->val_binary(E_DEC_FATAL_ERROR & ~E_DEC_OVERFLOW, ptr, precision, dec);
+
   if (warn_if_overflow(error))
   {
     if (error != E_DEC_TRUNCATED)
     {
       type::Decimal buff;
       set_value_on_overflow(&buff, decimal_value->sign());
-      class_decimal2binary(E_DEC_FATAL_ERROR, &buff, ptr, precision, dec);
+      buff.val_binary(E_DEC_FATAL_ERROR, ptr, precision, dec);
     }
     error= 1;
   }
+
   return(error);
 }
 
@@ -148,10 +149,9 @@
 
   ASSERT_COLUMN_MARKED_FOR_WRITE;
 
-  if ((err= str2_class_decimal(E_DEC_FATAL_ERROR &
+  if ((err= decimal_value.store(E_DEC_FATAL_ERROR &
                            ~(E_DEC_OVERFLOW | E_DEC_BAD_NUM),
-                           from, length, charset_arg,
-                           &decimal_value)) &&
+                           from, length, charset_arg)) &&
       getTable()->in_use->abort_on_warning)
   {
     /* Because "from" is not NUL-terminated and we use %s in the ER() */
@@ -187,7 +187,7 @@
                           ER(ER_TRUNCATED_WRONG_VALUE_FOR_FIELD),
                           "decimal", from_as_str.c_ptr(), field_name,
                           (uint32_t) getTable()->in_use->row_count);
-      class_decimal_set_zero(&decimal_value);
+      decimal_value.set_zero();
 
       break;
     }
@@ -285,7 +285,7 @@
 
   ASSERT_COLUMN_MARKED_FOR_READ;
 
-  class_decimal2int(E_DEC_FATAL_ERROR, val_decimal(&decimal_value), false, &i);
+  val_decimal(&decimal_value)->val_int32(E_DEC_FATAL_ERROR, false, &i);
 
   return i;
 }

=== modified file 'drizzled/field/varstring.cc'
--- drizzled/field/varstring.cc	2010-12-25 01:27:46 +0000
+++ drizzled/field/varstring.cc	2010-12-27 19:16:17 +0000
@@ -173,8 +173,8 @@
 
   length= length_bytes == 1 ? (uint32_t) *ptr : uint2korr(ptr);
 
-  str2_class_decimal(E_DEC_FATAL_ERROR, (char*) ptr+length_bytes, length,
-                 charset(), decimal_value);
+  decimal_value->store(E_DEC_FATAL_ERROR, (char*) ptr+length_bytes, length, charset());
+
   return decimal_value;
 }
 

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2010-12-25 01:27:46 +0000
+++ drizzled/filesort.cc	2010-12-26 17:38:28 +0000
@@ -925,9 +925,9 @@
             }
             *to++=1;
           }
-          class_decimal2binary(E_DEC_FATAL_ERROR, dec_val, to,
-                            item->max_length - (item->decimals ? 1:0),
-                            item->decimals);
+          dec_val->val_binary(E_DEC_FATAL_ERROR, to,
+                              item->max_length - (item->decimals ? 1:0),
+                              item->decimals);
           break;
         }
       case REAL_RESULT:

=== modified file 'drizzled/function/math/decimal_typecast.cc'
--- drizzled/function/math/decimal_typecast.cc	2010-12-25 01:27:46 +0000
+++ drizzled/function/math/decimal_typecast.cc	2010-12-26 22:31:33 +0000
@@ -53,7 +53,9 @@
   int64_t res;
   if (null_value)
     return 0;
-  class_decimal2int(E_DEC_FATAL_ERROR, tmp, unsigned_flag, &res);
+
+  tmp->val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &res);
+
   return res;
 }
 
@@ -72,7 +74,7 @@
   {
     if (sign)
     {
-      class_decimal_set_zero(dec);
+      dec->set_zero();
       goto err;
     }
   }

=== modified file 'drizzled/function/numhybrid.cc'
--- drizzled/function/numhybrid.cc	2010-12-25 01:27:46 +0000
+++ drizzled/function/numhybrid.cc	2010-12-27 19:16:17 +0000
@@ -117,7 +117,7 @@
       if (!(val= decimal_op(&decimal_value)))
         return 0;                                 // null is set
       int64_t result;
-      class_decimal2int(E_DEC_FATAL_ERROR, val, unsigned_flag, &result);
+      val->val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
       return result;
     }
   case INT_RESULT:
@@ -169,8 +169,8 @@
       if (!(res= str_op(&str_value)))
         return NULL;
 
-      str2_class_decimal(E_DEC_FATAL_ERROR, (char*) res->ptr(),
-                     res->length(), res->charset(), decimal_value);
+      decimal_value->store(E_DEC_FATAL_ERROR, (char*) res->ptr(),
+                           res->length(), res->charset());
       break;
     }
   case ROW_RESULT:

=== modified file 'drizzled/function/str/strfunc.cc'
--- drizzled/function/str/strfunc.cc	2010-12-25 01:27:46 +0000
+++ drizzled/function/str/strfunc.cc	2010-12-27 19:16:17 +0000
@@ -59,10 +59,11 @@
   char buff[64];
   String *res, tmp(buff,sizeof(buff), &my_charset_bin);
   res= val_str(&tmp);
-  if (!res)
+  if (not res)
     return 0;
-  (void)str2_class_decimal(E_DEC_FATAL_ERROR, (char*) res->ptr(),
-                       res->length(), res->charset(), decimal_value);
+
+  (void)decimal_value->store(E_DEC_FATAL_ERROR, (char*) res->ptr(), res->length(), res->charset());
+
   return decimal_value;
 }
 

=== modified file 'drizzled/hybrid_type_traits_decimal.cc'
--- drizzled/hybrid_type_traits_decimal.cc	2010-12-25 01:27:46 +0000
+++ drizzled/hybrid_type_traits_decimal.cc	2010-12-26 22:31:33 +0000
@@ -47,7 +47,7 @@
 
 void Hybrid_type_traits_decimal::set_zero(Hybrid_type *val) const
 {
-  class_decimal_set_zero(&val->dec_buf[0]);
+  val->dec_buf[0].set_zero();
   val->used_dec_buf_no= 0;
 }
 
@@ -82,8 +82,8 @@
 Hybrid_type_traits_decimal::val_int(Hybrid_type *val, bool unsigned_flag) const
 {
   int64_t result;
-  class_decimal2int(E_DEC_FATAL_ERROR, &val->dec_buf[val->used_dec_buf_no],
-                 unsigned_flag, &result);
+  val->dec_buf[val->used_dec_buf_no].val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
+
   return result;
 }
 

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2010-12-25 04:38:28 +0000
+++ drizzled/item.cc	2010-12-27 19:16:17 +0000
@@ -101,7 +101,7 @@
       type::Decimal decimal_value;
       type::Decimal *val= val_decimal(&decimal_value);
       if (val)
-        return !class_decimal_is_zero(val);
+        return not val->is_zero();
       return false;
     }
 
@@ -177,11 +177,10 @@
     return NULL;
 
   end_ptr= (char*) res->ptr()+ res->length();
-  if (str2_class_decimal(E_DEC_FATAL_ERROR & ~E_DEC_BAD_NUM,
+  if (decimal_value->store(E_DEC_FATAL_ERROR & ~E_DEC_BAD_NUM,
                      res->ptr(), 
                      res->length(), 
-                     res->charset(),
-                     decimal_value) & E_DEC_BAD_NUM)
+                     res->charset()) & E_DEC_BAD_NUM)
   {
     push_warning_printf(current_session, 
                         DRIZZLE_ERROR::WARN_LEVEL_WARN,
@@ -198,7 +197,7 @@
   type::Time ltime;
   if (get_date(&ltime, TIME_FUZZY_DATE))
   {
-    class_decimal_set_zero(decimal_value);
+    decimal_value->set_zero();
     null_value= 1;                               // set NULL, stop processing
     return NULL;
   }
@@ -211,7 +210,7 @@
   type::Time ltime;
   if (get_time(&ltime))
   {
-    class_decimal_set_zero(decimal_value);
+    decimal_value->set_zero();
     return NULL;
   }
   return date2_class_decimal(&ltime, decimal_value);
@@ -235,7 +234,7 @@
   type::Decimal value, *dec_val= val_decimal(&value);
   if (null_value)
     return 0;
-  class_decimal2int(E_DEC_FATAL_ERROR, dec_val, unsigned_flag, &result);
+  dec_val->val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
   return result;
 }
 

=== modified file 'drizzled/item/cache_decimal.cc'
--- drizzled/item/cache_decimal.cc	2010-12-25 01:27:46 +0000
+++ drizzled/item/cache_decimal.cc	2010-12-26 08:07:57 +0000
@@ -43,7 +43,7 @@
 {
   assert(fixed);
   int64_t res;
-  class_decimal2int(E_DEC_FATAL_ERROR, &decimal_value, unsigned_flag, &res);
+  decimal_value.val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &res);
   return res;
 }
 

=== modified file 'drizzled/item/cache_str.cc'
--- drizzled/item/cache_str.cc	2010-12-25 01:27:46 +0000
+++ drizzled/item/cache_str.cc	2010-12-27 19:16:17 +0000
@@ -80,7 +80,7 @@
 {
   assert(fixed == 1);
   if (value)
-    string2_class_decimal(E_DEC_FATAL_ERROR, value, decimal_val);
+    decimal_val->store(E_DEC_FATAL_ERROR, value);
   else
     decimal_val= 0;
   return decimal_val;

=== modified file 'drizzled/item/copy_string.cc'
--- drizzled/item/copy_string.cc	2010-12-25 01:27:46 +0000
+++ drizzled/item/copy_string.cc	2010-12-27 19:16:17 +0000
@@ -47,7 +47,8 @@
   // Item_copy_string is used without fix_fields call
   if (null_value)
     return 0;
-  string2_class_decimal(E_DEC_FATAL_ERROR, &str_value, decimal_value);
+  decimal_value->store(E_DEC_FATAL_ERROR, &str_value);
+
   return (decimal_value);
 }
 

=== modified file 'drizzled/item/decimal.cc'
--- drizzled/item/decimal.cc	2010-12-25 01:27:46 +0000
+++ drizzled/item/decimal.cc	2010-12-27 19:16:17 +0000
@@ -27,7 +27,7 @@
 Item_decimal::Item_decimal(const char *str_arg, uint32_t length,
                            const CHARSET_INFO * const charset)
 {
-  str2_class_decimal(E_DEC_FATAL_ERROR, str_arg, length, charset, &decimal_value);
+  decimal_value.store(E_DEC_FATAL_ERROR, str_arg, length, charset);
   name= (char*) str_arg;
   decimals= (uint8_t) decimal_value.frac;
   fixed= 1;
@@ -88,7 +88,7 @@
 int64_t Item_decimal::val_int()
 {
   int64_t result;
-  class_decimal2int(E_DEC_FATAL_ERROR, &decimal_value, unsigned_flag, &result);
+  decimal_value.val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
   return result;
 }
 

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2010-12-25 04:38:28 +0000
+++ drizzled/item/field.cc	2010-12-26 22:31:33 +0000
@@ -329,7 +329,7 @@
       type::Decimal decimal_value;
       type::Decimal *val= result_field->val_decimal(&decimal_value);
       if (val)
-        return !class_decimal_is_zero(val);
+        return not val->is_zero();
       return 0;
     }
 

=== modified file 'drizzled/item/ref.cc'
--- drizzled/item/ref.cc	2010-12-25 04:38:28 +0000
+++ drizzled/item/ref.cc	2010-12-26 22:31:33 +0000
@@ -457,7 +457,7 @@
         type::Decimal decimal_value;
         type::Decimal *val= result_field->val_decimal(&decimal_value);
         if (val)
-          return !class_decimal_is_zero(val);
+          return not val->is_zero();
         return 0;
       }
 

=== modified file 'drizzled/item/sum.cc'
--- drizzled/item/sum.cc	2010-12-25 01:27:46 +0000
+++ drizzled/item/sum.cc	2010-12-27 19:16:17 +0000
@@ -683,7 +683,7 @@
     break;
   case DECIMAL_RESULT:
     max_length= item->max_length;
-    class_decimal_set_zero(&sum_dec);
+    sum_dec.set_zero();
     break;
   case REAL_RESULT:
     max_length= float_length(decimals);
@@ -784,7 +784,7 @@
   if (hybrid_type == DECIMAL_RESULT)
   {
     curr_dec_buff= 0;
-    class_decimal_set_zero(dec_buffs);
+    dec_buffs->set_zero();
   }
   else
     sum= 0.0;
@@ -811,7 +811,7 @@
                                                  unsigned_flag);
       curr_dec_buff= 0;
       hybrid_type= DECIMAL_RESULT;
-      class_decimal_set_zero(dec_buffs);
+      dec_buffs->set_zero();
       break;
     }
   case ROW_RESULT:
@@ -849,8 +849,7 @@
   if (hybrid_type == DECIMAL_RESULT)
   {
     int64_t result;
-    class_decimal2int(E_DEC_FATAL_ERROR, dec_buffs + curr_dec_buff, unsigned_flag,
-                   &result);
+    (dec_buffs + curr_dec_buff)->val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
     return result;
   }
   return (int64_t) rint(val_real());
@@ -1603,7 +1602,7 @@
     sum_int= 0;
     break;
   case DECIMAL_RESULT:
-    class_decimal_set_zero(&sum_dec);
+    sum_dec.set_zero();
     break;
   case REAL_RESULT:
     sum= 0.0;
@@ -1656,7 +1655,7 @@
   case DECIMAL_RESULT:
   {
     int64_t result;
-    class_decimal2int(E_DEC_FATAL_ERROR, &sum_dec, unsigned_flag, &result);
+    sum_dec.val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
     return sum_int;
   }
   default:
@@ -1673,7 +1672,7 @@
 
   switch (hybrid_type) {
   case STRING_RESULT:
-    string2_class_decimal(E_DEC_FATAL_ERROR, &value, val);
+    val->store(E_DEC_FATAL_ERROR, &value);
     break;
   case REAL_RESULT:
     double2_class_decimal(E_DEC_FATAL_ERROR, sum, val);
@@ -2080,7 +2079,7 @@
     }
     else
       tmp= 1;
-    class_decimal2binary(E_DEC_FATAL_ERROR, arg_dec, res, f_precision, f_scale);
+    arg_dec->val_binary(E_DEC_FATAL_ERROR, res, f_precision, f_scale);
     res+= dec_bin_size;
     int8store(res, tmp);
   }
@@ -2183,8 +2182,7 @@
                         dec_buffs + 1, f_precision, f_scale);
       field_count= sint8korr(res + dec_bin_size);
       class_decimal_add(E_DEC_FATAL_ERROR, dec_buffs, arg_val, dec_buffs + 1);
-      class_decimal2binary(E_DEC_FATAL_ERROR, dec_buffs,
-                        res, f_precision, f_scale);
+      dec_buffs->val_binary(E_DEC_FATAL_ERROR, res, f_precision, f_scale);
       res+= dec_bin_size;
       field_count++;
       int8store(res, field_count);

=== modified file 'drizzled/type/decimal.cc'
--- drizzled/type/decimal.cc	2010-12-26 00:07:57 +0000
+++ drizzled/type/decimal.cc	2010-12-27 19:16:17 +0000
@@ -195,8 +195,8 @@
 */
 
 int class_decimal2string(uint32_t mask, const type::Decimal *d,
-                      uint32_t fixed_prec, uint32_t fixed_dec,
-                      char filler, String *str)
+                         uint32_t fixed_prec, uint32_t fixed_dec,
+                         char filler, String *str)
 {
   /*
     Calculate the size of the string: For DECIMAL(a,b), fixed_prec==a
@@ -211,7 +211,7 @@
   */
   int length= (int)(fixed_prec
                     ? (uint32_t)(fixed_prec + ((fixed_prec == fixed_dec) ? 1 : 0) + 1)
-                    : (uint32_t)class_decimal_string_length(d));
+                    : (uint32_t)d->string_length());
   int result;
   if (str->alloc(length))
     return check_result(mask, E_DEC_OOM);
@@ -242,12 +242,13 @@
    @retval E_DEC_OVERFLOW
 */
 
-int class_decimal2binary(uint32_t mask, const type::Decimal *d, unsigned char *bin, int prec,
-		      int scale)
+namespace type {
+
+int Decimal::val_binary(uint32_t mask, unsigned char *bin, int prec, int scale) const
 {
   int err1= E_DEC_OK, err2;
   type::Decimal rounded;
-  class_decimal2decimal(d, &rounded);
+  class_decimal2decimal(this, &rounded);
   rounded.frac= decimal_actual_fraction(&rounded);
   if (scale < rounded.frac)
   {
@@ -261,6 +262,8 @@
   return check_result(mask, err2);
 }
 
+} // namespace type
+
 
 /**
   @brief Convert string for decimal when string can be in some multibyte charset
@@ -269,7 +272,6 @@
   @param  from            string to process
   @param  length          length of given string
   @param  charset         charset of given string
-  @param  decimal_value   buffer for result storing
 
   @return Error code
    @retval E_DEC_OK
@@ -279,8 +281,7 @@
    @retval E_DEC_OOM
 */
 
-int str2_class_decimal(uint32_t mask, const char *from, uint32_t length,
-                   const CHARSET_INFO * charset, type::Decimal *decimal_value)
+int type::Decimal::store(uint32_t mask, const char *from, uint32_t length, const CHARSET_INFO * charset)
 {
   char *end, *from_end;
   int err;
@@ -295,7 +296,7 @@
     charset= &my_charset_bin;
   }
   from_end= end= (char*) from+length;
-  err= string2decimal((char *)from, (decimal_t*) decimal_value, &end);
+  err= string2decimal((char *)from, (decimal_t*) this, &end);
   if (end != from_end && !err)
   {
     /* Give warning if there is something other than end space */
@@ -308,7 +309,7 @@
       }
     }
   }
-  check_result_and_overflow(mask, err, decimal_value);
+  check_result_and_overflow(mask, err);
   return err;
 }
 

=== modified file 'drizzled/type/decimal.h'
--- drizzled/type/decimal.h	2010-12-26 01:00:32 +0000
+++ drizzled/type/decimal.h	2010-12-27 19:16:17 +0000
@@ -113,6 +113,8 @@
 
 #define E_DEC_ERROR            31
 #define E_DEC_FATAL_ERROR      30
+
+
 #define DECIMAL_LONGLONG_DIGITS 22
 #define DECIMAL_LONG_DIGITS 10
 #define DECIMAL_LONG3_DIGITS 8
@@ -145,52 +147,15 @@
 */
 #define DECIMAL_MAX_FIELD_SIZE DECIMAL_MAX_PRECISION
 
+namespace type {
+class Decimal;
+}
+
 inline int class_decimal_int_part(uint32_t precision, uint32_t decimals)
 {
   return precision - ((decimals == DECIMAL_NOT_SPECIFIED) ? 0 : decimals);
 }
 
-
-namespace type {
-/**
-  type::Decimal class limits 'decimal_t' type to what we need in MySQL.
-
-  It contains internally all necessary space needed by the instance so
-  no extra memory is needed. One should call fix_buffer_pointer() function
-  when he moves type::Decimal objects in memory.
-*/
-
-class Decimal :public decimal_t
-{
-  decimal_digit_t buffer[DECIMAL_BUFF_LENGTH];
-
-public:
-
-  void init()
-  {
-    len= DECIMAL_BUFF_LENGTH;
-    buf= buffer;
-	#if !defined (HAVE_VALGRIND)
-		/* Set buffer to 'random' value to find wrong buffer usage */
-		for (uint32_t i= 0; i < DECIMAL_BUFF_LENGTH; i++)
-		  buffer[i]= i;
-	#endif
-  }
-
-  Decimal()
-  {
-    init();
-  }
-  void fix_buffer_pointer() { buf= buffer; }
-  bool sign() const { return decimal_t::sign; }
-  void sign(bool s) { decimal_t::sign= s; }
-  uint32_t precision() const { return intg + frac; }
-};
-
-} // type
-
-std::ostream& operator<<(std::ostream& output, const type::Decimal &dec);
-
 int decimal_operation_results(int result);
 
 inline void max_Decimal(type::Decimal *to, int precision, int frac)
@@ -212,37 +177,116 @@
   return result;
 }
 
-inline int check_result_and_overflow(uint32_t mask, int result, type::Decimal *val)
-{
-  if (check_result(mask, result) & E_DEC_OVERFLOW)
+namespace type {
+/**
+  type::Decimal class limits 'decimal_t' type to what we need in MySQL.
+
+  It contains internally all necessary space needed by the instance so
+  no extra memory is needed. One should call fix_buffer_pointer() function
+  when he moves type::Decimal objects in memory.
+*/
+
+class Decimal :public decimal_t
   {
-    bool sign= val->sign();
-    val->fix_buffer_pointer();
-    max_internal_decimal(val);
-    val->sign(sign);
-  }
-  return result;
+    decimal_digit_t buffer[DECIMAL_BUFF_LENGTH];
+
+  public:
+
+    void init()
+    {
+      len= DECIMAL_BUFF_LENGTH;
+      buf= buffer;
+#if !defined (HAVE_VALGRIND)
+      /* Set buffer to 'random' value to find wrong buffer usage */
+      for (uint32_t i= 0; i < DECIMAL_BUFF_LENGTH; i++)
+        buffer[i]= i;
+#endif
+    }
+
+    Decimal()
+    {
+      init();
+    }
+    void fix_buffer_pointer() { buf= buffer; }
+    bool sign() const { return decimal_t::sign; }
+    void sign(bool s) { decimal_t::sign= s; }
+    uint32_t precision() const { return intg + frac; }
+
+    int val_int32(uint32_t mask, bool unsigned_flag, int64_t *l) const
+    {
+      type::Decimal rounded;
+      /* decimal_round can return only E_DEC_TRUNCATED */
+      decimal_round(static_cast<const decimal_t*>(this), &rounded, 0, HALF_UP);
+      return check_result(mask, (unsigned_flag ?
+                                 decimal2uint64_t(&rounded, reinterpret_cast<uint64_t *>(l)) :
+                                 decimal2int64_t(&rounded, l)));
+    }
+
+    int string_length() const
+    {
+      return decimal_string_size(this);
+    }
+
+    int val_binary(uint32_t mask, unsigned char *bin, int prec, int scale) const;
+
+
+    int set_zero()
+    {
+      decimal_make_zero(static_cast<decimal_t*> (this));
+      return 0;
+    }
+
+
+    bool is_zero() const
+    {
+      return decimal_is_zero(static_cast<const decimal_t*>(this));
+    }
+
+
+    int store(uint32_t mask, const char *from, uint32_t length, const CHARSET_INFO * charset);
+
+    int store(uint32_t mask, char *str, char **end)
+    {
+      return check_result_and_overflow(mask, string2decimal(str, static_cast<decimal_t*>(this), end));
+    }
+
+    int store(uint32_t mask, const String *str)
+    {
+      return store(mask, str->ptr(), str->length(), str->charset());
+    }
+
+    int check_result_and_overflow(uint32_t mask, int result)
+    {
+      if (check_result(mask, result) & E_DEC_OVERFLOW)
+      {
+        bool _sign= sign();
+        fix_buffer_pointer();
+        max_internal_decimal(this);
+        sign(_sign);
+      }
+      return result;
 }
 
+
+  };
+
+} // type
+
+std::ostream& operator<<(std::ostream& output, const type::Decimal &dec);
+
 inline uint32_t class_decimal_length_to_precision(uint32_t length, uint32_t scale,
-                                           bool unsigned_flag)
+                                                  bool unsigned_flag)
 {
   return (uint32_t) (length - (scale>0 ? 1:0) - (unsigned_flag ? 0:1));
 }
 
 inline uint32_t class_decimal_precision_to_length(uint32_t precision, uint8_t scale,
-                                             bool unsigned_flag)
+                                                  bool unsigned_flag)
 {
   set_if_smaller(precision, (uint32_t)DECIMAL_MAX_PRECISION);
   return static_cast<uint32_t>(precision + (scale>0 ? 1:0) + (unsigned_flag ? 0:1));
 }
 
-inline
-int class_decimal_string_length(const type::Decimal *d)
-{
-  return decimal_string_size(d);
-}
-
 
 inline
 int class_decimal_max_length(const type::Decimal *d)
@@ -267,10 +311,6 @@
 }
 
 
-int class_decimal2binary(uint32_t mask, const type::Decimal *d, unsigned char *bin, int prec,
-		      int scale);
-
-
 inline
 int binary2_class_decimal(uint32_t mask, const unsigned char *bin, type::Decimal *d, int prec,
 		      int scale)
@@ -280,21 +320,6 @@
 
 
 inline
-int class_decimal_set_zero(type::Decimal *d)
-{
-  decimal_make_zero(static_cast<decimal_t*> (d));
-  return 0;
-}
-
-
-inline
-bool class_decimal_is_zero(const type::Decimal *decimal_value)
-{
-  return decimal_is_zero(static_cast<const decimal_t*>(decimal_value));
-}
-
-
-inline
 int class_decimal_round(uint32_t mask, const type::Decimal *from, int scale,
                      bool truncate, type::Decimal *to)
 {
@@ -320,18 +345,6 @@
 int class_decimal2string(uint32_t mask, const type::Decimal *d, uint32_t fixed_prec,
                       uint32_t fixed_dec, char filler, String *str);
 
-inline
-int class_decimal2int(uint32_t mask, const type::Decimal *d, bool unsigned_flag,
-                   int64_t *l)
-{
-  type::Decimal rounded;
-  /* decimal_round can return only E_DEC_TRUNCATED */
-  decimal_round(static_cast<const decimal_t*>(d), &rounded, 0, HALF_UP);
-  return check_result(mask, (unsigned_flag ?
-			     decimal2uint64_t(&rounded, reinterpret_cast<uint64_t *>(l)) :
-			     decimal2int64_t(&rounded, l)));
-}
-
 
 inline
 int class_decimal2double(uint32_t, const type::Decimal *d, double *result)
@@ -341,31 +354,13 @@
 }
 
 
-inline
-int str2_class_decimal(uint32_t mask, char *str, type::Decimal *d, char **end)
-{
-  return check_result_and_overflow(mask, string2decimal(str, static_cast<decimal_t*>(d),end),
-                                   d);
-}
-
-
-int str2_class_decimal(uint32_t mask, const char *from, uint32_t length,
-                   const CHARSET_INFO * charset, type::Decimal *decimal_value);
-
-inline
-int string2_class_decimal(uint32_t mask, const String *str, type::Decimal *d)
-{
-  return str2_class_decimal(mask, str->ptr(), str->length(), str->charset(), d);
-}
-
-
 type::Decimal *date2_class_decimal(type::Time *ltime, type::Decimal *dec);
 
 
 inline
 int double2_class_decimal(uint32_t mask, double val, type::Decimal *d)
 {
-  return check_result_and_overflow(mask, double2decimal(val, static_cast<decimal_t*>(d)), d);
+  return d->check_result_and_overflow(mask, double2decimal(val, static_cast<decimal_t*>(d)));
 }
 
 
@@ -394,10 +389,9 @@
 int class_decimal_add(uint32_t mask, type::Decimal *res, const type::Decimal *a,
 		   const type::Decimal *b)
 {
-  return check_result_and_overflow(mask,
-                                   decimal_add(static_cast<const decimal_t*>(a),
-                                               static_cast<const decimal_t*>(b), res),
-                                   res);
+  return res->check_result_and_overflow(mask,
+                                        decimal_add(static_cast<const decimal_t*>(a),
+                                                    static_cast<const decimal_t*>(b), res));
 }
 
 
@@ -405,10 +399,9 @@
 int class_decimal_sub(uint32_t mask, type::Decimal *res, const type::Decimal *a,
 		   const type::Decimal *b)
 {
-  return check_result_and_overflow(mask,
-                                   decimal_sub(static_cast<const decimal_t*>(a),
-                                               static_cast<const decimal_t*>(b), res),
-                                   res);
+  return res->check_result_and_overflow(mask,
+                                        decimal_sub(static_cast<const decimal_t*>(a),
+                                                    static_cast<const decimal_t*>(b), res));
 }
 
 
@@ -416,10 +409,9 @@
 int class_decimal_mul(uint32_t mask, type::Decimal *res, const type::Decimal *a,
 		   const type::Decimal *b)
 {
-  return check_result_and_overflow(mask,
-                                   decimal_mul(static_cast<const decimal_t*>(a),
-                                               static_cast<const decimal_t*>(b),res),
-                                   res);
+  return res->check_result_and_overflow(mask,
+                                        decimal_mul(static_cast<const decimal_t*>(a),
+                                                    static_cast<const decimal_t*>(b),res));
 }
 
 
@@ -427,11 +419,10 @@
 int class_decimal_div(uint32_t mask, type::Decimal *res, const type::Decimal *a,
 		   const type::Decimal *b, int div_scale_inc)
 {
-  return check_result_and_overflow(mask,
-                                   decimal_div(static_cast<const decimal_t*>(a),
-                                               static_cast<const decimal_t*>(b),res,
-                                               div_scale_inc),
-                                   res);
+  return res->check_result_and_overflow(mask,
+                                        decimal_div(static_cast<const decimal_t*>(a),
+                                                    static_cast<const decimal_t*>(b),res,
+                                                    div_scale_inc));
 }
 
 
@@ -439,10 +430,9 @@
 int class_decimal_mod(uint32_t mask, type::Decimal *res, const type::Decimal *a,
 		   const type::Decimal *b)
 {
-  return check_result_and_overflow(mask,
-                                   decimal_mod(static_cast<const decimal_t*>(a),
-                                               static_cast<const decimal_t*>(b),res),
-                                   res);
+  return res->check_result_and_overflow(mask,
+                                        decimal_mod(static_cast<const decimal_t*>(a),
+                                                    static_cast<const decimal_t*>(b),res));
 }
 
 

=== modified file 'drizzled/user_var_entry.cc'
--- drizzled/user_var_entry.cc	2010-12-25 01:27:46 +0000
+++ drizzled/user_var_entry.cc	2010-12-27 19:16:17 +0000
@@ -73,7 +73,7 @@
   case DECIMAL_RESULT:
     {
       int64_t result;
-      class_decimal2int(E_DEC_FATAL_ERROR, (type::Decimal *)value, 0, &result);
+      ((type::Decimal *)(value))->val_int32(E_DEC_FATAL_ERROR, 0, &result);
       return result;
     }
 
@@ -149,7 +149,7 @@
     break;
 
   case STRING_RESULT:
-    str2_class_decimal(E_DEC_FATAL_ERROR, value, length, collation.collation, val);
+    val->store(E_DEC_FATAL_ERROR, value, length, collation.collation);
     break;
 
   case ROW_RESULT:

=== modified file 'plugin/math_functions/ceiling.cc'
--- plugin/math_functions/ceiling.cc	2010-12-25 01:27:46 +0000
+++ plugin/math_functions/ceiling.cc	2010-12-26 08:07:57 +0000
@@ -36,7 +36,7 @@
   {
     type::Decimal dec_buf, *dec;
     if ((dec= Item_func_ceiling::decimal_op(&dec_buf)))
-      class_decimal2int(E_DEC_FATAL_ERROR, dec, unsigned_flag, &result);
+      dec->val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
     else
       result= 0;
     break;

=== modified file 'plugin/math_functions/floor.cc'
--- plugin/math_functions/floor.cc	2010-12-25 01:27:46 +0000
+++ plugin/math_functions/floor.cc	2010-12-26 08:07:57 +0000
@@ -36,7 +36,7 @@
   {
     type::Decimal dec_buf, *dec;
     if ((dec= Item_func_floor::decimal_op(&dec_buf)))
-      class_decimal2int(E_DEC_FATAL_ERROR, dec, unsigned_flag, &result);
+      dec->val_int32(E_DEC_FATAL_ERROR, unsigned_flag, &result);
     else
       result= 0;
     break;

